<template>
	<div ref="initialPage">
		<div
			class="bg-white mx-auto w-full lg:w-960 md:rounded-lg lg:rounded px-4 pt-6 pb-8 md:px-6 md:pt-6 md:pb-9 lg:p-14"
		>
			<h2
				:class="orders.length ? 'py-0 lg:px-0' : 'lg:px-0'"
				class="font-secondary-font-regular text-xl md:text-2xl lg:text-base2 leading-6 md:leading-7 lg:leading-10"
			>
				Orders
			</h2>
			<div v-if="orders.length == 0" class="mt-7">
				<p class="text-sm leading-6">You do not have any orders.</p>
			</div>
			<div v-else role="table" aria-describedby="orders">
				<div id="orders" class="hidden">Orders</div>
				<div class="hidden md:grid md:mt-8 lg:mt-14">
					<div
						role="row"
						class="grid auto-cols-fr grid-flow-col md:col-span-10 font-primary-font-bold text-base md:text-sm lg:text-base leading-6 md:leading-5 lg:leading-6"
					>
						<p role="columnheader" class="md:col-span-2">Order #</p>
						<p role="columnheader" class="md:col-span-2">Date</p>
						<p role="columnheader" class="md:col-span-2">Order total</p>
						<p class="md:col-span-2"></p>
						<p class="md:col-span-2"></p>
					</div>
				</div>
				<div :class="viewOrder.length ? 'md:mt-6 lg:mt-8 border-b border-grey-20 hidden md:block' : ''"></div>
				<div
					v-for="(item, index) in viewOrder"
					:key="index"
					role="row"
					:class="{ 'border-b border-grey-20': index != orders.length }"
					class="grid auto-cols-fr md:grid-flow-col md:grid-cols-10 items-center md:mt-0 pt-9 pb-8 md:pt-6 md:pb-7 lg:py-6 font-primary-font-bold text-sm leading-5 gap-2"
				>
					<div class="md:hidden">
						<div class="grid">
							<div class="">
								<div
									role="cell"
									class="font-primary-font-bold text-base leading-6 grid grid-flow-col justify-between gap-x-4"
								>
									<p>Order #</p>
									<p :class="item.trackingId && !isEurope ? 'font-primary-font-bold' : 'font-primary-font-light'">{{
										item.orderNumber
									}}</p>
								</div>
								<div
									role="cell"
									class="font-primary-font-bold text-base leading-6 grid grid-flow-col mt-2 justify-between gap-x-4"
								>
									<p>Date</p>
									<p :class="item.trackingId && !isEurope ? 'font-primary-font-bold' : 'font-primary-font-light'">{{
										item.orderDate | ustToDate
									}}</p>
								</div>
								<div
									role="cell"
									class="font-primary-font-bold text-base leading-6 grid grid-flow-col mt-2 justify-between gap-x-4"
								>
									<p>Order total</p>
									<p :class="item.trackingId && !isEurope ? 'font-primary-font-bold' : 'font-primary-font-light'"
										>{{ currencyDisplay }}{{ item.orderTotal | centsToDollars }}</p
									>
								</div>
								<div v-if="item.isGiftOrder" role="cell" class="grid grid-flow-col mt-2 justify-start">
									<MkGiftIcon />
									<p class="ml-2">This is a gift</p>
								</div>
								<!-- <div  role="cell" class="grid grid-flow-col mt-2 justify-start">
                                    <div class="w-5 md:col-span-2 ">
                                        <img src="~/assets/images/clyde.svg" class="w-full" alt="clyde">
                                    </div>
                                </div>  -->
							</div>
						</div>
						<div role="cell" class="grid grid-flow-col justify-center mt-4">
							<a
								v-if="item.trackingId && !isEurope"
								ref="track_btn"
								tabindex="0"
								:href="`http://www.fedex.com/Tracking?tracknumbers=${item.trackingId}`"
								class="flex justify-center items-center px-8 border-0 rounded-3xl border-grey-20 focus:outline-none active:outline-none font-primary-font-light focus:ring cursor-pointer mx-auto hover:bg-grey-40 bg-black text-white min-w-150 md:min-w-90 lg:min-w-150 text-sm mr-6 ml-0 py-1.5 leading-5"
								target="_blank"
							>
								Track
							</a>
							<MkTerritoryButton
								ref="view_btn"
								mkterritory-width="h-8 min-w-150 md:w-24 min-w-150"
								tabindex="0"
								class="focus:ring-1 focus:ring-black min-w-150 font-primary-font-regular leading-4 pt-2 pb-1.5 items-center"
								:aria-label="item.orderNumber + ' Order View'"
								button-title="View"
								@click="clickOrderDetail(item)"
							/>
						</div>
					</div>
					<div role="cell" class="hidden md:grid grid-flow-row md:col-span-2">
						<span
							:class="item.trackingId && !isEurope ? 'font-primary-font-bold' : 'font-primary-font-light'"
							class="text-base md:text-sm lg:text-base text-black leading-6 md:leading-5 lg:leading-6 md:col-span-2"
							>{{ item.orderNumber }}</span
						>
						<div v-if="item.isGiftOrder" class="flex mt-2">
							<MkGiftIcon />
							<p class="ml-2">This is a gift</p>
						</div>
						<!-- <div class="grid grid-flow-col mt-2">
                            <div class="w-5 md:col-span-2 ">
                                <img src="~/assets/images/clyde.svg" class="w-full" alt="clyde">
                            </div>
                        </div> -->
					</div>
					<span
						role="cell"
						:class="item.trackingId && !isEurope ? 'font-primary-font-bold' : 'font-primary-font-light'"
						class="text-base md:text-sm lg:text-base text-black leading-6 md:leading-5 lg:leading-6 hidden md:block md:col-span-2"
						>{{ item.orderDate | ustToDate }}</span
					>
					<span
						role="cell"
						:class="item.trackingId && !isEurope ? 'font-primary-font-bold' : 'font-primary-font-light'"
						class="text-base md:text-sm lg:text-base text-black leading-6 md:leading-5 lg:leading-6 hidden md:block md:col-span-2 col-end-7"
						>{{ currencyDisplay }}{{ item.orderTotal | centsToDollars }}</span
					>
					<div role="cell" class="hidden md:col-span-2 md:flex justify-end">
						<a
							v-if="item.trackingId && !isEurope"
							ref="track_button"
							tabindex="0"
							:href="`http://www.fedex.com/Tracking?tracknumbers=${item.trackingId}`"
							class="flex justify-center items-center px-8 border-0 rounded-3xl border-grey-20 focus:outline-none active:outline-none font-primary-font-light focus:ring cursor-pointer mx-auto hover:bg-grey-40 bg-black text-white min-w-150 md:min-w-90 lg:min-w-150 text-sm mx-0 mr-6 ml-0 py-1.5 leading-5"
							target="_blank"
							>Track</a
						>
					</div>
					<div role="cell" class="hidden md:col-span-2 md:flex justify-end">
						<MkTerritoryButton
							ref="view_button"
							:aria-label="item.orderNumber + ' Order View'"
							tabindex="0"
							class="focus:ring-1 focus:ring-black md:w-90 lg:min-w-150 font-primary-font-regular leading-4 pt-2 pb-1.5"
							button-title="View"
							@click="clickOrderDetail(item)"
						/>
					</div>
				</div>
			</div>
		</div>
		<div class="mx-auto w-full lg:w-960 bg-white md:rounded-lg lg:rounded my-2 md:my-6 lg:my-2">
			<div :class="orders.length ? 'px-4 py-5 md:px-0 md:py-5 lg:py-7' : ''">
				<MkPageNavigation v-if="orders.length > 0" :pages="calculateVisibleOrders" @click="showOrders($event)" />
			</div>
		</div>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkTerritoryButton from '~/components/D2C/atoms/MkTerritoryButton.vue';
import MkGiftIcon from '~/components/D2C/atoms/MkGiftIcon.vue';
import MkPageNavigation from '~/components/D2C/atoms/MkPageNavigation.vue';
export default {
	name: 'MkOrders',
	components: {
		MkTerritoryButton,
		MkGiftIcon,
		MkPageNavigation,
	},
	data() {
		return {
			orders: [],
			pages: {
				pageNo: [1],
				currentPage: 1,
			},
			totalPages: 1,
			viewOrder: [],
			viewCount: 10, // count to be show in view
			currentIndex: 0,
		};
	},
	computed: {
		...mapState('USER_STORE', ['ORDERS', 'AUTHENTICATED']),
		...mapState(['currencyDisplay', 'isEurope']),
		calculateVisibleOrders() {
			const numOfOrders = this.orders && this.orders.length;
			this.handlePagination(numOfOrders);
			return this.pages;
		},
	},
	watch: {
		AUTHENTICATED() {
			if (this.AUTHENTICATED) {
				this.getOrder();
			}
		},
	},
	mounted() {
		if (this.AUTHENTICATED) {
			this.getOrder();
		}
	},
	updated() {
		const self = this;
		if (this.viewOrder && this.viewOrder.length && this.viewOrder[self.currentIndex].trackingId) {
			self.$nextTick().then(function () {
				self.$refs.track_button[self.currentIndex].focus();
				self.$refs.track_btn[self.currentIndex].focus();
			});
		} else {
			self.$nextTick().then(function () {
				if (self.$refs.view_button && self.$refs.view_button.length) {
					self.$refs.view_button[self.currentIndex].$el.focus();
					self.$refs.view_btn[self.currentIndex].$el.focus();
				}
			});
		}
	},
	methods: {
		showOrders(val) {
			let selectedVal = 1;
			let totalCount = 0;
			let tempOrders = [];
			let maxVal = 0;
			let minVal = 0;
			if (val && val.target) {
				if (val.target.textContent) {
					selectedVal = val && val.target && parseInt(val.target.textContent);
				} else if (val.target.id === 'first') {
					selectedVal = 1;
				} else if (val.target.id === 'last') {
					selectedVal = this.totalPages;
				}
			}
			totalCount = this.viewCount;
			tempOrders = [...this.orders];
			maxVal = selectedVal * totalCount;
			minVal = maxVal - totalCount;
			this.$set(this.pages, 'currentPage', selectedVal);
			this.viewOrder = tempOrders.slice(minVal, maxVal);
			this.$forceUpdate();
			window.scrollTo(0, this.$refs?.initialPage?.offsetTop - 300);
		},
		clickOrderDetail(item) {
			const successUrl = `/D2C/account/order?orderId=${item.orderId}`;
			this.$router.push(successUrl);
		},
		async getOrder() {
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			await this.$store.dispatch('USER_STORE/GET_ORDERS');
			try {
				this.orders = this.ORDERS.results || [];
				this.viewOrder = [...this.orders];
				this.showOrders();
			} catch (error) {
				console.log(error);
				this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			}
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
		},
		handlePagination(numOfOrders) {
			if (numOfOrders > this.viewCount) {
				this.pages.pageNo = [];
				this.showOrders();
				const pageNo = numOfOrders / this.viewCount;
				this.totalPages = Math.floor(pageNo) + 1;
				if (pageNo % 1 === 0) {
					this.totalPages = pageNo;
				}
				for (let i = 1; i <= this.totalPages; i++) {
					this.pages.pageNo.push(i);
				}
			}
		},
	},
};
</script>
